#include <linux/ppdev.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/io.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <unistd.h>
#include <syslog.h>
#include <string.h>
#include <signal.h>
#include <pthread.h>

#define FIPATH "/var/tmp/buzzd.fifo"
#define DAEMON_NAME "[buzzd]"
#define TRUE 1
#define FALSE 0
  
int running = FALSE;
char paths[3][256];	
int term = FALSE;

void signal_handler(int sig) {
 
    switch(sig) {
        case SIGHUP:
            syslog(LOG_WARNING, "Received SIGHUP signal.");
            break;
        case SIGTERM:
            syslog(LOG_WARNING, "Received SIGTERM signal.");
            break;
        default:
            syslog(LOG_WARNING, "Unhandled signal (%d) %s", strsignal(sig));
            break;
    }
}

void runscript(int buznr){
  if(running == FALSE){
    if(paths[buznr - 1] != NULL){
      running == TRUE;
      system(paths[buznr - 1]);
    }
  }
  running == FALSE;
}

void *runfifo(){
int fifi;
mkfifo(FIPATH, O_RDWR );
fifi = open(FIPATH, O_RDWR);
char spath[256];	
char bid[1]:
char lpath[255];
read(fifi, spath, 2);

  while(1){
    
  }
	close(fifi);
}

int main (int argc, char *argv[]){
	int option, daemonize = 0;
	int port = 0, i;
	const int base_adr[3] = {0x3bc, 0x378, 0x278};
	unsigned char r;


	while((option = getopt(argc,argv,"hd")) >= 0){
		switch(option){
		case 'h': {
		printf("Usage: %s [-d] [-h]\n-d: Daemonize\n -h: help\n",argv[0]);
		return 0;
		}
		break;
		case 'd':{
		daemonize = 1;
		}
		break;
		case '?':{
		printf("Wrong option:\n Maybe you want to try %s -h\n",argv[0]);
		}
	}
 }
        /* Open any logs here */

	syslog(LOG_INFO, "%s daemon starting up", DAEMON_NAME);
	setlogmask(LOG_UPTO(LOG_INFO));
	openlog(DAEMON_NAME, LOG_CONS, LOG_USER);
	
	if(daemonize == 1){
	pid_t pid, sid;
	
	syslog(LOG_INFO, "starting the daemonizing process");

	signal(SIGHUP, signal_handler);
	signal(SIGTERM, signal_handler);
    	signal(SIGINT, signal_handler);
    	signal(SIGQUIT, signal_handler);
	
	

	/* Fork off the parent process */
        pid = fork();
        if (pid < 0) {
                exit(EXIT_FAILURE);
        }
        /* If we got a good PID, then
           we can exit the parent process. */
        if (pid > 0) {
                exit(EXIT_SUCCESS);
        }
        
        /* Change the file mode mask */
        umask(0);
       
        /* Create a new SID for the child process */
        sid = setsid();
        if (sid < 0) {
                /* Log any failure */
                exit(EXIT_FAILURE);
        }

	/* Change the current working directory */
        if ((chdir("/")) < 0) {
                /* Log any failure here */
                exit(EXIT_FAILURE);
        }

	/* Close out the standard file descriptors */
        close(STDIN_FILENO);
        close(STDOUT_FILENO);
        close(STDERR_FILENO);
	}
	
	/*Port gedoenz*/
	/*ioperm(BASE, 1, 1);*/

	/*open paralell port*/
	if (iopl(3) != 0){
	syslog(LOG_INFO, "%s: cant set I/O permission", DAEMON_NAME);
	return 1;
	}
	
	for (i=0; i<3; i++){
		outb_p(0, base_adr[i]);
		if (inb_p(base_adr[i]) == 0){
			port = base_adr[i];
			syslog(LOG_INFO,"base_adr: %x\n", base_adr[i]);
		}
	}
	
	if (port == 0){
		syslog(LOG_INFO, "cant set I/O permission", DAEMON_NAME);
		return 1;
	}
	else{
		syslog(LOG_INFO, "Port found at: %x", DAEMON_NAME, port);
	}

  pthread_t fifo_script;
  pthread_create(&fifo_script, NULL, runfifo, NULL);

	/*read data*/
  int polde;

	while (1){
	

	/*printf("FIFO: \"%s\" \n",spath);*/
        int portin;
       
        portin = inb(port+1);
        
       if(portin != polde){
          if(portin == 0xDF){
            syslog(LOG_INFO, "Buzzer 1 pressed");
            runscript(1);            
          }
          if(portin == 0x7F){
             syslog(LOG_INFO, "Buzzer 1 pressed");
             runscript(2);
          }
          if(portin == 0xBF){
            syslog(LOG_INFO, "Buzzer 1 pressed");
            runscript(3);
          }
          polde = portin;
	        usleep(230);
       }
	}
	
	syslog(LOG_INFO, "%s daemon exiting", DAEMON_NAME);
	/*close port*/

	return (0);
}
